import java.awt.BasicStroke;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.RenderingHints;

import java.awt.event.*;
import java.awt.geom.*;
import java.awt.image.*;
import javax.swing.*;
import java.util.Map;
import java.util.HashMap;
import java.util.Random;

import static java.lang.Math.*;

public class Life implements Runnable {
	LifeGame game;

	public Life (String...args) {
		int	rows = 25;
		int	cols = 25;

		for (String arg : args) {
			if (arg.indexOf(':') > 0) {
				String[] parts = arg.split(":");

				if (parts.length != 2) continue;

				if ("-rows".equals(parts[0])) {
					rows = Integer.parseInt(parts[1]);
				}

				if ("-cols".equals(parts[0])) {
					cols = Integer.parseInt(parts[1]);
				}
			}
		}

		game = new LifeGame(rows, cols);
	}

	@Override
	@SuppressWarnings("unchecked")
	public void run () {
		final JFrame frame = new JFrame("Life");

		final JPanel panel = new JPanel () {
			final BasicStroke stroke = new BasicStroke(1.0f, BasicStroke.CAP_ROUND, BasicStroke.JOIN_ROUND);

			@Override
			public void paintComponent (Graphics g) {
				Graphics2D graphics = (Graphics2D)g;

				int width = getWidth();
				int height = getHeight();

				graphics.setColor(Color.WHITE);
				graphics.fillRect(0, 0, width, height);

				//~ for (int i = 0; i < rows; ++i) {
				//~ }

			}
		};

		new Timer(750, new ActionListener() {
			@Override
			public void actionPerformed (ActionEvent event) {

				panel.repaint();
			}
		}).start();

		frame.setLayout(new BorderLayout());
		frame.add(panel, BorderLayout.CENTER);

		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		frame.setVisible(true);
		frame.setSize(800, 600);
	}

	public static void main (String...args) {
		SwingUtilities.invokeLater(new Life(args));
	}
}
